      implicit real*8 (a-h,o-z)

      include 'CONSTCOM.'
      INCLUDE 'PDFCOM.'
      include 'PRECCOM.'

      real*8 q2lhbench(5)
      data q2lhbench /2d0, 4d0, 10d0, 24d0, 100d0/ 

#ifndef TOYLH
      print *,'******THIS BENCH IS APPLICABLE FOR THE TOYLH PDFS ONLY'
      STOP
#endif

!  Set up constants, grid spacing, etc.
      call initgridconst
!  Set improved accuracy of the integration  
      nf2hq=8
      nmthq=8

!  Set the c-quark mass
      rmass(8)=sqrt(2d0)
!  Set the b-quark mass
      rmass(10)=4.5

!  The NNLO approximation for the strong coupling 
      kordalps=2

!  Set up the 3-flavour NNLO PDFs and fill the 3-flavour PDF grid
!  including the strong coupling values
      kschemepdf=0
      kordpdf=2
      call pdffillgrid

!  Filling the 4-flavour PDF grid  
      call fillvfngrid

!  Set the factorization scale to Q, as motivated by the VFN schemes
      hqscale2=0d0

! The non-singlet contribution is not included into the 3-flavor term
      hqnons=.false.

      print *,'The c-quark semi-inclusive structure functions F_2^c', 
     -' (first column: momentum transferred in GeV^2,',
     -' second column: x, third column: 3-flavour FFNS value of F_2^c',
     -' 4-th column: asymptotic value of F_2^c in the 3-flavour scheme,',
     -' 5-th column: ZMVFNS value of F_2^c,',
     -' 6-th column: GMVFNS value of F_2^c in the BMSN prescription)'

!  Check the case of c-quark production (ihqn=10 for the case of b-quark)
      ihqn=8

      print *,'O(\alpha_s^2) approximation'
      kordhq=1  !   O(\alpha_s^2)
      do n=1,5
        q2=q2lhbench(n)
        do nn=1,5
          xb=10.**(nn-6)
          a1=f2charm_ffn(xb,q2,ihqn)
          a2=f2h_asymp(3,1,22,xb,q2,ihqn)
          a3=f2h_vfn(3,1,22,xb,q2,ihqn)
          a4=f2h_bmsn(3,1,22,xb,q2,ihqn)
          write (*,fmt='(6e13.4)') q2,xb,a1,a2,a3,a4
        end do
      end do

      print *,'O(\alpha_s^3) approximation'
      kordhq=2  !   O(\alpha_s^3)
      do n=1,5
        q2=q2lhbench(n)
        do nn=1,5
          xb=10.**(nn-6)
          a1=f2charm_ffn(xb,q2,ihqn)
          write (*,fmt='(6e13.4)') q2,xb,a1
        end do
      end do

      stop
      end
