      real*8 function useralphas(q2,kschemepdf,kordpdf)
      implicit real*8 (a-h,o-z)

!  Must returns the value of strong coupling at the scale of q2
!  for the 3-flavour scheme (kschemepdf=0), 
!  for the 4-flavour scheme (kschemepdf=1), or 
!  for the 5-flavour scheme (kschemepdf=2) 

!  kordpdf=0  --  LO
!  kordpdf=1  --  NLO
!  kordpdf=2  --  NNLO
      character name*80
      real*8 f(-6:6)
      common /foruserpdfs/ inituser
      data inituser /0/ 

      if (inituser.eq.0) then 

!  Select for the 5-flavour NNLO PDFs the preliminary NNLO HERAPDFs 
!  (small-alpha_s variant) obtained by courtesy of A.Glasov. In order to make 
!  use of this option one has to copy the file 
!
!  $(top_builddir)/user/HERAPDF1.0_NNLO_1145.LHgrid, 
!
!  which contain the PDF grid in the LHAPDF format, to the standard LHAPDF 
!  grid place. 

        if (kschemepdf.eq.2) then 
          if (kordpdf.eq.2) name='HERAPDF1.0_NNLO_1145.LHgrid'
        end if

!  Select for the 3-flavour NNLO PDFs ones obtained in the variant of ABKM09 fit
!  with the MSbar definition of the heavy-quark masses (cf. [arXiv:1011.6259]).
!  In order to make use of this option one has to copy the file 
!
!  $(top_builddir)/user/abkm09_msbar_3_nnlo.LHgrid, 
!
!  which contain the PDF grid in the LHAPDF format, to the standard LHAPDF 
!  grid place. 

        if (kschemepdf.eq.0) then 
          if (kordpdf.eq.2) name='abkm09_msbar_3_nnlo.LHgrid'
        end if
        call initPDFSetByName(name)
!  Take the central PDF set 
        call InitPDF(0)
        inituser=1
      end if

      useralphas=alphasPDF(sqrt(q2))

      return 
      end      
!------------------------
      real*8 function userpdfs(xb,q2,iq,kschemepdf,kordpdf)
      implicit real*8 (a-h,o-z)

!  Must return the value of PDFs times xb at the scale of q2
!  for the 3-flavour scheme (kschemepdf=0) or
!  for the 4-flavour scheme (kschemepdf=1) or 
!  for the 5-flavour scheme (kschemepdf=2) 

!  kordpdf=0  --  LO
!  kordpdf=1  --  NLO
!  kordpdf=2  --  NNLO
 
!  iq=0 -- gluon
!  iq=1 -- d-quark
!  iq=-1 -- anti-d-quark
!  iq=2 -- u-quark
!  iq=-2 -- anti-u-quark
!  iq=3 -- s-quark
!  iq=-3 -- anti-s-quark
!  iq=4 -- c-quark
!  iq=-4 -- anti-c-quark
!  iq=5 -- b-quark
!  iq=-5 -- anti-b-quark

      character name*80
      real*8 f(-6:6)
      common /foruserpdfs/ inituser
      data inituser /0/ 

      if (inituser.eq.0) then 

!  Select for the 5-flavour NNLO PDFs the preliminary NNLO HERAPDFs 
!  (small-alpha_s variant) obtained by courtesy of A.Glasov. In order to make 
!  use of this option one has to copy the file 
!
!  $(top_builddir)/user/HERAPDF1.0_NNLO_1145.LHgrid, 
!
!  which contain the PDF grid in the LHAPDF format, to the standard LHAPDF 
!  grid place. 

        if (kschemepdf.eq.2) then 
          if (kordpdf.eq.2) name='HERAPDF1.0_NNLO_1145.LHgrid'
        end if

!  Select for the 3-flavour NNLO PDFs ones obtained in the variant of ABKM09 fit
!  with the MSbar definition of the heavy-quark masses (cf. [arXiv:1011.6259]).
!  In order to make use of this option one has to copy the file 
!
!  $(top_builddir)/user/abkm09_msbar_3_nnlo.LHgrid, 
!
!  which contain the PDF grid in the LHAPDF format, to the standard LHAPDF 
!  grid place. 

        if (kschemepdf.eq.0) then 
          if (kordpdf.eq.2) name='abkm09_msbar_3_nnlo.LHgrid'
        end if
        call initPDFSetByName(name)
!  Take the central PDF set 
        call InitPDF(0)
        inituser=1
      end if

      call evolvePDF(xb,sqrt(q2),f)
      userpdfs=f(iq)

      return 
      end
